diff -Nur lwip/src/core/ipv4/igmp.c lwip-mcast/src/core/ipv4/igmp.c
--- lwip/src/core/ipv4/igmp.c	Fri Jan 26 13:32:36 2018
+++ lwip-mcast/src/core/ipv4/igmp.c	Sat Jan 27 16:47:40 2018
@@ -64,14 +64,19 @@
 but not checked rigorously incoming
 -------------------------------------------------------------
 Steve Reynolds
+-------------------------------------------------------------
+Note 4)
+Add support to IGMPv3
+-------------------------------------------------------------
+Han.hui
 ------------------------------------------------------------*/
 
 /*-----------------------------------------------------------------------------
  * RFC 988  - Host extensions for IP multicasting                         - V0
  * RFC 1054 - Host extensions for IP multicasting                         -
  * RFC 1112 - Host extensions for IP multicasting                         - V1
- * RFC 2236 - Internet Group Management Protocol, Version 2               - V2  <- this code is based on this RFC (it's the "de facto" standard)
- * RFC 3376 - Internet Group Management Protocol, Version 3               - V3
+ * RFC 2236 - Internet Group Management Protocol, Version 2               - V2
+ * RFC 3376 - Internet Group Management Protocol, Version 3               - V3  <- this code is based on this RFC
  * RFC 4604 - Using Internet Group Management Protocol Version 3...       - V3+
  * RFC 2113 - IP Router Alert Option                                      -
  *----------------------------------------------------------------------------*/
@@ -93,6 +98,7 @@
 #include "lwip/netif.h"
 #include "lwip/stats.h"
 #include "lwip/prot/igmp.h"
+#include "lwip/mcast.h"
 
 #include "string.h"
 
@@ -104,9 +110,22 @@
 static err_t  igmp_ip_output_if(struct pbuf *p, const ip4_addr_t *src, const ip4_addr_t *dest, struct netif *netif);
 static void   igmp_send(struct netif *netif, struct igmp_group *group, u8_t type);
 
+#if LWIP_IGMP_V3
+static void   igmp_v3_timeout(struct netif *netif, struct igmp_group *group);
+static void   igmp_v3_start_timer(struct igmp_group *group, u8_t max_time);
+static void   igmp_v3_delaying_member(struct igmp_group *group, u8_t maxresp);
+static void   igmp_v3_send(struct netif *netif, struct igmp_group *group, u8_t type);
+static void   igmp_v3_send_allgroups(struct netif *netif);
+static void   igmp_v3_trigger(struct netif *netif, const ip4_addr_t *groupaddr);
+#endif /* LWIP_IGMP_V3 */
+
 static ip4_addr_t     allsystems;
 static ip4_addr_t     allrouters;
 
+#if LWIP_IGMP_V3
+static ip4_addr_t     v3_routers;
+#endif /* LWIP_IGMP_V3 */
+
 /**
  * Initialize the IGMP module
  */
@@ -117,6 +136,12 @@
 
   IP4_ADDR(&allsystems, 224, 0, 0, 1);
   IP4_ADDR(&allrouters, 224, 0, 0, 2);
+
+#if LWIP_IGMP_V3
+  IP4_ADDR(&v3_routers, 224, 0, 0, 22);
+  
+  mcast_ip4_filter_trigger_callback(igmp_v3_trigger); /* install multicast filter trigger callback */
+#endif /* LWIP_IGMP_V3 */
 }
 
 /**
@@ -136,6 +161,9 @@
   if (group != NULL) {
     group->group_state = IGMP_GROUP_IDLE_MEMBER;
     group->use++;
+#if LWIP_IGMP_V3
+    group->v3_group_state = IGMP_GROUP_IDLE_MEMBER;
+#endif /* LWIP_IGMP_V3 */
 
     /* Allow the igmp messages at the MAC level */
     if (netif->igmp_mac_filter != NULL) {
@@ -204,6 +232,15 @@
     igmp_delaying_member(group, IGMP_JOIN_DELAYING_MEMBER_TMR);
     group = group->next;
   }
+
+#if LWIP_IGMP_V3
+  group = netif_igmp_data(netif);
+  
+  if (group) {
+    /* We use first group to determine report all groups */
+    igmp_v3_delaying_member(group, IGMP_JOIN_DELAYING_MEMBER_TMR);
+  }
+#endif /* LWIP_IGMP_V3 */
 }
 
 /**
@@ -261,6 +298,12 @@
     group->group_state        = IGMP_GROUP_NON_MEMBER;
     group->last_reporter_flag = 0;
     group->use                = 0;
+#if LWIP_IGMP_V3
+    group->v3_fmode              = IGMP_FMODE_INIT; /* Non mode with init-stat */
+    group->v3_timer              = 0; /* Not running */
+    group->v3_group_state        = IGMP_GROUP_NON_MEMBER;
+    group->v3_last_reporter_flag = 0;
+#endif /* LWIP_IGMP_V3 */
 
     /* Ensure allsystems group is always first in list */
     if (list_head == NULL) {
@@ -365,6 +408,69 @@
   /* NOW ACT ON THE INCOMING MESSAGE TYPE... */
   switch (igmp->igmp_msgtype) {
     case IGMP_MEMB_QUERY:
+#if LWIP_IGMP_V3
+      if (p->len >= IGMP_V3_MINLEN) { /* this is a igmp v3 query packet */
+        struct igmp_v3_query  *igmp_v3 = (struct igmp_v3_query *)p->payload;
+        
+        if ((ip4_addr_cmp(dest, &allsystems)) && ip4_addr_isany(&igmp_v3->igmp_v3_group_address)) {
+          /* THIS IS THE GENERAL QUERY */
+          groupref = netif_igmp_data(inp);
+          
+          if (groupref) {
+            /* We use first group to determine report all groups */
+            igmp_v3_delaying_member(groupref, igmp_v3->igmp_v3_maxresp);
+          }
+        
+        } else {
+          /* IGMP_MEMB_QUERY to a specific group ? */
+          if (!ip4_addr_isany(&igmp_v3->igmp_v3_group_address)) {
+            u16_t src_cnt = PP_NTOHS(igmp_v3->igmp_v3_srccnt);
+            u16_t src_buf_size = src_cnt << 2;
+            u8_t need_free;
+            ip4_addr_p_t *src_buf;
+            
+            if (p->tot_len < (IGMP_V3_QUERY_HLEN + src_buf_size)) {
+              /* packet len error */
+              pbuf_free(p);
+              IGMP_STATS_INC(igmp.lenerr);
+              LWIP_DEBUGF(IGMP_DEBUG, ("igmp_input: length error\n"));
+              return;
+            }
+            
+            if (src_cnt) { /* Seach interest */
+              if (p->len < (IGMP_V3_QUERY_HLEN + src_buf_size)) { /* Unfortunately! the source address memory is not contiguous */
+                src_buf = (ip4_addr_p_t *)mem_malloc(src_buf_size);
+                if (src_buf == NULL) {
+                  pbuf_free(p);
+                  IGMP_STATS_INC(igmp.memerr);
+                  LWIP_DEBUGF(IGMP_DEBUG, ("igmp_input: not enough memory for igmp_input\n"));
+                  return;
+                }
+                need_free = 1;
+                pbuf_copy_partial(p, src_buf, src_buf_size, IGMP_V3_QUERY_HLEN);
+
+              } else {
+                need_free = 0;
+                src_buf = (ip4_addr_p_t *)((u8_t *)p->payload + IGMP_V3_QUERY_HLEN);
+              }
+              
+              LWIP_ASSERT("igmp_v3_query packet source address array not aligned!", !((mem_ptr_t)src_buf & 0x3));
+              if (mcast_ip4_filter_interest(inp, (const ip4_addr_t *)&igmp_v3->igmp_v3_group_address, src_buf, src_cnt)) {
+                /* We interest! */
+                igmp_v3_delaying_member(group, igmp_v3->igmp_v3_maxresp);
+              }
+              
+              if (need_free) {
+                mem_free(src_buf);
+              }
+
+            } else { /* Report! */
+              igmp_v3_delaying_member(group, igmp_v3->igmp_v3_maxresp);
+            }
+          }
+        }
+      }
+#endif /* LWIP_IGMP_V3 */
       /* IGMP_MEMB_QUERY to the "all systems" address ? */
       if ((ip4_addr_cmp(dest, &allsystems)) && ip4_addr_isany(&igmp->igmp_group_address)) {
         /* THIS IS THE GENERAL QUERY */
@@ -455,7 +561,9 @@
 
   /* make sure it is multicast address */
   LWIP_ERROR("igmp_joingroup: attempt to join non-multicast address", ip4_addr_ismulticast(groupaddr), return ERR_VAL;);
-  LWIP_ERROR("igmp_joingroup: attempt to join allsystems address", (!ip4_addr_cmp(groupaddr, &allsystems)), return ERR_VAL;);
+  if (ip4_addr_cmp(groupaddr, &allsystems)) {
+    return (ERR_OK); /* already in allsystem group */
+  }
 
   /* loop through netif's */
   NETIF_FOREACH(netif) {
@@ -490,7 +598,9 @@
 
   /* make sure it is multicast address */
   LWIP_ERROR("igmp_joingroup_netif: attempt to join non-multicast address", ip4_addr_ismulticast(groupaddr), return ERR_VAL;);
-  LWIP_ERROR("igmp_joingroup_netif: attempt to join allsystems address", (!ip4_addr_cmp(groupaddr, &allsystems)), return ERR_VAL;);
+  if (ip4_addr_cmp(groupaddr, &allsystems)) {
+    return (ERR_OK); /* already in allsystem group */
+  }
 
   /* make sure it is an igmp-enabled netif */
   LWIP_ERROR("igmp_joingroup_netif: attempt to join on non-IGMP netif", netif->flags & NETIF_FLAG_IGMP, return ERR_VAL;);
@@ -523,6 +633,15 @@
 
       /* Need to work out where this timer comes from */
       group->group_state = IGMP_GROUP_DELAYING_MEMBER;
+
+#if LWIP_IGMP_V3
+      igmp_v3_send(netif, group, IGMP_V3_MEMB_REPORT);
+      
+      igmp_v3_start_timer(group, IGMP_JOIN_DELAYING_MEMBER_TMR);
+      
+      /* Need to work out where this timer comes from */
+      group->v3_group_state = IGMP_GROUP_DELAYING_MEMBER;
+#endif /* LWIP_IGMP_V3 */
     }
     /* Increment group use */
     group->use++;
@@ -552,7 +671,9 @@
 
   /* make sure it is multicast address */
   LWIP_ERROR("igmp_leavegroup: attempt to leave non-multicast address", ip4_addr_ismulticast(groupaddr), return ERR_VAL;);
-  LWIP_ERROR("igmp_leavegroup: attempt to leave allsystems address", (!ip4_addr_cmp(groupaddr, &allsystems)), return ERR_VAL;);
+  if (ip4_addr_cmp(groupaddr, &allsystems)) {
+    return (ERR_OK); /* do not leave allsystem group */
+  }
 
   /* loop through netif's */
   NETIF_FOREACH(netif) {
@@ -586,7 +707,9 @@
 
   /* make sure it is multicast address */
   LWIP_ERROR("igmp_leavegroup_netif: attempt to leave non-multicast address", ip4_addr_ismulticast(groupaddr), return ERR_VAL;);
-  LWIP_ERROR("igmp_leavegroup_netif: attempt to leave allsystems address", (!ip4_addr_cmp(groupaddr, &allsystems)), return ERR_VAL;);
+  if (ip4_addr_cmp(groupaddr, &allsystems)) {
+    return (ERR_OK); /* do not leave allsystem group */
+  }
 
   /* make sure it is an igmp-enabled netif */
   LWIP_ERROR("igmp_leavegroup_netif: attempt to leave on non-IGMP netif", netif->flags & NETIF_FLAG_IGMP, return ERR_VAL;);
@@ -612,6 +735,13 @@
         igmp_send(netif, group, IGMP_LEAVE_GROUP);
       }
 
+#if LWIP_IGMP_V3
+      /* If we are the last reporter for this group */
+      if (group->v3_last_reporter_flag) {
+        igmp_v3_send(netif, group, IGMP_LEAVE_GROUP);
+      }
+#endif /* LWIP_IGMP_V3 */
+
       /* Disable the group at the MAC level */
       if (netif->igmp_mac_filter != NULL) {
         LWIP_DEBUGF(IGMP_DEBUG, ("igmp_leavegroup_netif: igmp_mac_filter(DEL "));
@@ -654,6 +784,19 @@
       }
       group = group->next;
     }
+    
+#if LWIP_IGMP_V3
+    group = netif_igmp_data(netif);
+    while (group != NULL) {
+      if (group->v3_timer > 0) {
+        group->v3_timer--;
+        if (group->v3_timer == 0) {
+          igmp_v3_timeout(netif, group);
+        }
+      }
+      group = group->next;
+    }
+#endif /* LWIP_IGMP_V3 */
   }
 }
 
@@ -681,6 +824,36 @@
   }
 }
 
+#if LWIP_IGMP_V3
+/**
+ * Called if a timeout for one group is reached.
+ * Sends a report for this group.
+ *
+ * @param group an igmp_group for which a timeout is reached
+ */
+static void
+igmp_v3_timeout(struct netif *netif, struct igmp_group *group)
+{
+  /* If the state is IGMP_GROUP_DELAYING_MEMBER then we send a report for this group
+     (if it is the allsystems group to all groups) */
+  if (group->v3_group_state == IGMP_GROUP_DELAYING_MEMBER) {
+    group->group_state = IGMP_GROUP_IDLE_MEMBER;
+    if (ip4_addr_cmp(&(group->group_address), &allsystems)) {
+      LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_timeout: report all membership\n"));
+      IGMP_STATS_INC(igmp.tx_report);
+      igmp_v3_send_allgroups(netif);
+      
+    } else {
+      LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_timeout: report membership for group with address "));
+      ip4_addr_debug_print(IGMP_DEBUG, &(group->group_address));
+      LWIP_DEBUGF(IGMP_DEBUG, (" on if %p\n", (void *)netif));
+      IGMP_STATS_INC(igmp.tx_report);
+      igmp_v3_send(netif, group, IGMP_V3_MEMB_REPORT);
+    }
+  }
+}
+#endif /* LWIP_IGMP_V3 */
+
 /**
  * Start a timer for an igmp group
  *
@@ -703,6 +876,51 @@
   }
 }
 
+#if LWIP_IGMP_V3
+/**
+ * Start a timer for an igmp group
+ *
+ * @param group the igmp_group for which to start a timer
+ * @param max_time the time in multiples of IGMP_TMR_INTERVAL (decrease with
+ *        every call to igmp_tmr())
+ */
+static void
+igmp_v3_start_timer(struct igmp_group *group, u8_t max_time)
+{
+  /*
+   * If Max Resp Code < 128, Max Resp Time = Max Resp Code
+   *
+   * If Max Resp Code >= 128, Max Resp Code represents a floating-point
+   * value as follows:
+   *
+   *   0 1 2 3 4 5 6 7
+   *  +-+-+-+-+-+-+-+-+
+   *  |1| exp | mant  |
+   *  +-+-+-+-+-+-+-+-+
+   *
+   *  Max Resp Time = (mant | 0x10) << (exp + 3)
+   */
+  u16_t delay;
+  
+  if (max_time < 128) {
+    delay = max_time;
+  } else {
+    delay = ((max_time & 0xf) | 0x10) << (((max_time >> 4) & 7) + 3);
+  }
+
+#ifdef LWIP_RAND
+  group->v3_timer = (u16_t)(delay > 2 ? (LWIP_RAND() % delay) : 1);
+#else /* LWIP_RAND */
+  /* ATTENTION: use this only if absolutely necessary! */
+  group->v3_timer = delay / 2;
+#endif /* LWIP_RAND */
+
+  if (group->v3_timer == 0) {
+    group->v3_timer = 1;
+  }
+}
+#endif /* LWIP_IGMP_V3 */
+
 /**
  * Delaying membership report for a group if necessary
  *
@@ -720,6 +938,32 @@
   }
 }
 
+#if LWIP_IGMP_V3
+/**
+ * Delaying membership report for a group if necessary
+ *
+ * @param group the igmp_group for which "delaying" membership report
+ * @param maxresp query delay
+ */
+static void
+igmp_v3_delaying_member(struct igmp_group *group, u8_t maxresp)
+{
+  u16_t delay;
+  
+  if (maxresp < 128) {
+    delay = maxresp;
+  } else {
+    delay = ((maxresp & 0xf) | 0x10) << (((maxresp >> 4) & 7) + 3);
+  }
+
+  if ((group->v3_group_state == IGMP_GROUP_IDLE_MEMBER) ||
+      ((group->v3_group_state == IGMP_GROUP_DELAYING_MEMBER) &&
+       ((group->v3_timer == 0) || (delay < group->timer)))) {
+    igmp_v3_start_timer(group, maxresp);
+    group->v3_group_state = IGMP_GROUP_DELAYING_MEMBER;
+  }
+}
+#endif /* LWIP_IGMP_V3 */
 
 /**
  * Sends an IP packet on a network interface. This function constructs the IP header
@@ -798,4 +1042,218 @@
   }
 }
 
+#if LWIP_IGMP_V3
+/**
+ * Build a igmp v3 record to a specific group.
+ *
+ * @param rec record to build
+ * @param group the group to which to send the packet
+ * @param fmode filter mode
+ * @param src_array source addr array
+ * @param src_cnt source addr cnt
+ */
+static void
+igmp_v3_build_record(struct igmp_v3_record *rec, struct igmp_group *group, u8_t fmode, ip4_addr_p_t *src_array, u32_t src_cnt)
+{
+  ip4_addr_p_t *src_copy;
+  
+  if (fmode == MCAST_EXCLUDE) {
+    if (group->v3_fmode != MCAST_EXCLUDE) {
+      group->v3_fmode = MCAST_EXCLUDE;
+      rec->igmp_v3_rc_type = IGMP_V3_REC_TO_EX;
+    } else {
+      rec->igmp_v3_rc_type = IGMP_V3_REC_IS_EX;
+    }
+
+  } else {
+    if (group->v3_fmode != MCAST_INCLUDE) {
+      group->v3_fmode = MCAST_INCLUDE;
+      rec->igmp_v3_rc_type = IGMP_V3_REC_TO_IN;
+    } else {
+      rec->igmp_v3_rc_type = IGMP_V3_REC_IS_IN;
+    }
+  }
+  
+  rec->igmp_v3_rc_auxlen = 0;
+  rec->igmp_v3_rc_srccnt = PP_HTONS(src_cnt);
+  ip4_addr_set(&rec->igmp_v3_rc_group_address, &group->group_address);
+
+  if (src_cnt) {
+    src_copy = (ip4_addr_p_t *)(rec + 1);
+    MEMCPY(src_copy, src_array, (src_cnt << 2));
+  }
+}
+/**
+ * Send an igmp v3 packet to a specific group.
+ *
+ * @param group the group to which to send the packet
+ * @param type the type of igmp packet to send
+ */
+static void
+igmp_v3_send(struct netif *netif, struct igmp_group *group, u8_t type)
+{
+  struct igmp_v3_report *rep;
+  struct igmp_v3_record *rec;
+  ip4_addr_t src;
+  struct pbuf *p;
+  
+  ip4_addr_copy(src, *netif_ip4_addr(netif));
+  
+  if (type == IGMP_LEAVE_GROUP) { /* Leave from a group */
+    p = pbuf_alloc(PBUF_TRANSPORT, IGMP_V3_REPORT_HLEN + IGMP_V3_RECORD_LEN(0), PBUF_RAM);
+    if (p == NULL) {
+      LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_send: not enough memory for igmp_v3_send\n"));
+      IGMP_STATS_INC(igmp.memerr);
+      return;
+    }
+    
+    rep = (struct igmp_v3_report *)p->payload;
+    rep->igmp_v3_msgtype  = IGMP_V3_MEMB_REPORT;
+    rep->igmp_v3_reserve1 = 0;
+    rep->igmp_v3_checksum = 0;
+    rep->igmp_v3_reserve2 = 0;
+    rep->igmp_v3_reccnt   = PP_HTONS(1);
+    
+    rec = (struct igmp_v3_record *)(rep + 1);
+    if (group->v3_fmode == MCAST_EXCLUDE) {
+      rec->igmp_v3_rc_type = IGMP_V3_REC_TO_IN;
+    } else {
+      rec->igmp_v3_rc_type = IGMP_V3_REC_IS_IN;
+    }
+    rec->igmp_v3_rc_auxlen = 0;
+    rec->igmp_v3_rc_srccnt = 0; /* IS_IN (NULL) mean drop group */
+    ip4_addr_set(&rec->igmp_v3_rc_group_address, &group->group_address);
+    rep->igmp_v3_checksum = inet_chksum(rep, IGMP_V3_REPORT_HLEN + IGMP_V3_RECORD_LEN(0));
+    
+  } else { /* Report a group */
+    ip4_addr_p_t src_array[LWIP_MCAST_SRC_TBL_SIZE];
+    u16_t src_cnt;
+    u8_t fmode;
+    
+    src_cnt = mcast_ip4_filter_info(netif, &group->group_address, src_array, LWIP_MCAST_SRC_TBL_SIZE, &fmode);
+    LWIP_ASSERT("igmp_v3_send: multicast filter error!", !(!src_cnt && (fmode == MCAST_INCLUDE)));
+    
+    p = pbuf_alloc(PBUF_TRANSPORT, IGMP_V3_REPORT_HLEN + IGMP_V3_RECORD_LEN(src_cnt), PBUF_RAM);
+    if (p == NULL) {
+      LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_send: not enough memory for igmp_v3_send\n"));
+      IGMP_STATS_INC(igmp.memerr);
+      return;
+    }
+    
+    rep = (struct igmp_v3_report *)p->payload;
+    rep->igmp_v3_msgtype  = IGMP_V3_MEMB_REPORT;
+    rep->igmp_v3_reserve1 = 0;
+    rep->igmp_v3_checksum = 0;
+    rep->igmp_v3_reserve2 = 0;
+    rep->igmp_v3_reccnt   = PP_HTONS(1);
+    
+    rec = (struct igmp_v3_record *)(rep + 1);
+    igmp_v3_build_record(rec, group, fmode, src_array, src_cnt);
+    rep->igmp_v3_checksum = inet_chksum(rep, IGMP_V3_REPORT_HLEN + IGMP_V3_RECORD_LEN(src_cnt));
+    group->v3_last_reporter_flag = 1; /* Remember we were the last to report */
+  }
+
+  igmp_ip_output_if(p, &src, &v3_routers, netif);
+  pbuf_free(p);
+}
+
+/**
+ * Send igmp v3 packet to report all groups.
+ */
+static void
+igmp_v3_send_allgroups(struct netif *netif)
+{
+  struct igmp_group *group;
+  struct igmp_v3_report *rep;
+  struct igmp_v3_record *rec;
+  struct pbuf *p, *p_rec;
+  ip4_addr_t src;
+  ip4_addr_p_t src_array[LWIP_MCAST_SRC_TBL_SIZE];
+  u16_t src_cnt;
+  u16_t max_pkt_len = (u16_t)(netif->mtu ? netif->mtu : 0xffff);
+  u8_t fmode;
+  
+  ip4_addr_copy(src, *netif_ip4_addr(netif));
+  
+  group = netif_igmp_data(netif);
+  if (group) {
+    group = group->next; /* do not report allsystem group */
+  }
+  
+  if (!group) {
+    return; /* no group */
+  }
+  
+  src_cnt = mcast_ip4_filter_info(netif, &group->group_address, src_array, LWIP_MCAST_SRC_TBL_SIZE, &fmode);
+  LWIP_ASSERT("igmp_v3_send: multicast filter error!", !(!src_cnt && (fmode == MCAST_INCLUDE)));
+  
+  while (group) {
+    p = pbuf_alloc(PBUF_TRANSPORT, IGMP_V3_REPORT_HLEN + IGMP_V3_RECORD_LEN(src_cnt), PBUF_RAM);
+    if (p == NULL) {
+      LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_send_allgroups: not enough memory for igmp_v3_send_allgroups\n"));
+      IGMP_STATS_INC(igmp.memerr);
+      return;
+    }
+    
+    rep = (struct igmp_v3_report *)p->payload;
+    rep->igmp_v3_msgtype  = IGMP_V3_MEMB_REPORT;
+    rep->igmp_v3_reserve1 = 0;
+    rep->igmp_v3_checksum = 0;
+    rep->igmp_v3_reserve2 = 0;
+    rep->igmp_v3_reccnt   = PP_HTONS(1);
+    
+    rec = (struct igmp_v3_record *)(rep + 1);
+    igmp_v3_build_record(rec, group, fmode, src_array, src_cnt);
+    group->v3_last_reporter_flag = 1; /* Remember we were the last to report */
+    
+cat_rec:
+    group = group->next; /* the next group */
+    if (group) {
+      src_cnt = mcast_ip4_filter_info(netif, &group->group_address, src_array, LWIP_MCAST_SRC_TBL_SIZE, &fmode);
+      LWIP_ASSERT("igmp_v3_send: multicast filter error!", !(!src_cnt && (fmode == MCAST_INCLUDE)));
+      
+      if (p->tot_len + IGMP_V3_RECORD_LEN(src_cnt) < max_pkt_len) { /* can add a record? */
+        p_rec = pbuf_alloc(PBUF_RAW, IGMP_V3_RECORD_LEN(src_cnt), PBUF_RAM);
+        if (p_rec) {
+          rep->igmp_v3_reccnt = PP_HTONS(PP_NTOHS(rep->igmp_v3_reccnt) + 1); /* add a record */
+          
+          rec = (struct igmp_v3_record *)p_rec->payload;
+          igmp_v3_build_record(rec, group, fmode, src_array, src_cnt);
+          group->v3_last_reporter_flag = 1; /* Remember we were the last to report */
+          pbuf_cat(p, p_rec); /* cat to tail */
+          goto cat_rec;
+        
+        } else {
+          LWIP_DEBUGF(IGMP_DEBUG, ("igmp_v3_send_allgroups: not enough memory for igmp_v3_send_allgroups\n"));
+          IGMP_STATS_INC(igmp.memerr);
+        }
+      }
+    }
+    
+    rep->igmp_v3_checksum = inet_chksum_pbuf(p);
+    igmp_ip_output_if(p, &src, &v3_routers, netif);
+    pbuf_free(p);
+  }
+}
+
+/**
+ * igmp v3 report trigger.
+ */
+static void
+igmp_v3_trigger(struct netif *netif, const ip4_addr_t *groupaddr)
+{
+  struct igmp_group *group;
+
+  /* find group */
+  group = igmp_lookfor_group(netif, groupaddr);
+  if (group) {
+    igmp_v3_send(netif, group, IGMP_V3_MEMB_REPORT);
+      
+    igmp_v3_start_timer(group, IGMP_JOIN_DELAYING_MEMBER_TMR);
+      
+    /* Need to work out where this timer comes from */
+    group->v3_group_state = IGMP_GROUP_DELAYING_MEMBER;
+  }
+}
+#endif /* LWIP_IGMP_V3 */
 #endif /* LWIP_IPV4 && LWIP_IGMP */
